<?php

    if ( !defined( 'ABSPATH' ) ) exit;

    class JVerySimpleFileUpload989 extends stdClass
    {
        private $options = null;
        private $is_writeable = false;
        
        public function __construct($options)
        {
            $this->options = $options;
            $this->options['token'] = $this->getToken();

            if (is_writeable(VERY_SIMPLE_FILE_UPLOAD_989_WP_ROOT . $this->options['target'])) {
                $this->is_writeable = true;

                $ajax_vars = array();
                // Javascript változók átadása
                // Set the javascript values
                if (count($ajax_vars) > 0) {
        			wp_register_script('very-simple-file-upload-'.$this->options['token'].'-variables-js', '', array('jquery'), false, true);
        			wp_localize_script('very-simple-file-upload-'.$this->options['token'].'-variables-js', 'very_simple_file_upload_variables_'.$this->options['token'], $ajax_vars);
        			wp_enqueue_script('very-simple-file-upload-'.$this->options['token'].'-variables-js');
                }
            }            
        }

        private function getToken()
        {
            $chars = 'ABCDEFGHIJKLMNOPQURSTXYVWZ0123456789';
            $token = '';
            for ($i = 1; $i <= 10; $i++) {
            	$token .= substr($chars, rand(0, strlen($chars)-1), 1);
            }                
            return $token;
        }

        function prepareContent()
        {   
            if (!$this->is_writeable) { 
                $html = "\r\n" . '<!-- Very simple fileupload: ' . 
                        sprintf(
                            __('Target folder not writeable! (%s)', 'very-simple-file-upload'), 
                            $this->options['target']) . 
                        ' -->' . "\r\n";
                return $html; 
            
            }
            
            $allowed = '*';
            if (isset($this->options['accept'])) {
                $allowed = explode(',', $this->options['accept']);
                $allowed = '.' . implode(',.', $allowed);            
            }

            $html = '<div id="very_simple_file_upload_'.$this->options['token'].'" class="very-simple-file-upload" data-plugin="very-simple-file-upload" data-token="'.$this->options['token'].'">' . "\r\n" .
                    "\t" . '<form id="files_upload_'.$this->options['token'].'" method="post" enctype="multipart/form-data">' . "\r\n" .
                    "\t\t" . '<label for="description_'.$this->options['token'].'">'. __('Document description:', 'very-simple-file-upload').'</label>' . "\r\n" .
                    "\t\t" . '<input type="text" class="input" id="description_'.$this->options['token'].'" name="description" value="" />' . "\r\n" .
                    "\t\t" . '<div style="clear:both;margin-bottom:6px;"></div>' . "\r\n" .
                    "\t\t" . '<label for="myfile_'.$this->options['token'].'">'. __('Select file(s)', 'very-simple-file-upload').':</label>' . "\r\n" .
                    "\t\t" . '<img src="'.plugins_url( 'very-simple-file-upload/assets/images/wait.gif', VERY_SIMPLE_FILE_UPLOAD_989_ROOT ).'" id="very_simple_upload_wait_'.$this->options['token'].'" style="display:none;" />' . "\r\n" .
                    "\t\t" . '<input type="file" class="input" id="myfile_'.$this->options['token'].'" name="myfile[]" multiple="multiple" accept="'.$allowed.'"  />' . "\r\n" .
                    "\t\t" . '<input type="submit" value="'. __('Upload selected file(s)', 'very-simple-file-upload').'" />' . "\r\n" .
                    "\t\t" . '<input type="hidden" name="action" value="very_simple_file_upload_989_fileupload" />' . "\r\n" .
                    "\t\t" . '<input type="hidden" name="filesName" value="myfile" />' . "\r\n" .
                    "\t\t" . '<input type="hidden" name="allowExt" value="'.$this->options['accept'].'" />' . "\r\n" .
                    "\t\t" . '<input type="hidden" name="maxSize" value="'.$this->options['max-size'].'" />' . "\r\n" .
                    "\t\t" . '<input type="hidden" name="uploadDir" value="'.$this->options['target'].'" />' . "\r\n" .
                    "\t\t" . '<input type="hidden" name="size" value="0" />' . "\r\n" .
                    "\t\t" . '<input type="hidden" name="token" value="'.$this->options['token'].'" />' . "\r\n";
            $html .= "\t" . '</form>' . "\r\n" .
                     "\t" . '<div id="err"></div>' . "\r\n" .
                     '</div>' . "\r\n";
                
            return $html;
        }
        
    }