<?php

if ( !defined( 'ABSPATH' ) ) exit;

class very_simple_file_upload_989_settings
{
    private $options;

    public function __construct()
    {
        add_action( 'admin_menu', array( $this, 'add_plugin_page' ) );
        add_action( 'admin_init', array( $this, 'page_init' ) );
    }

    public function add_plugin_page()
    {
        // This page will be under "Settings"
        add_options_page(
            'Settings Admin', 
            __('Very Simple File Upload settings', 'very-simple-file-upload'), 
            'manage_options', 
            'very-simple-file-upload-setting-admin', 
            array( $this, 'create_admin_page' )
        );
    }

    public function create_admin_page()
    {
        ?>
        <style>.form-table td {padding: 0px 10px 0 10px;}</style>
        <div class="wrap">
            <h1><?php echo __('Very Simple File Upload settings', 'very-simple-file-upload');?></h1>
            <div class="very-simple-file-upload-setting-page">
                <div>
                    <p style="text-align: justify;"><?php echo __('Insert form the content:', 'very-simple-file-upload');?> <code>[very-simple-file-upload target="<span style="color:#CB0101;">REQUIRED!</span>" <em>&lsaquo;user="0"&rsaquo;</em> <em>&lsaquo;accept=""&rsaquo;</em> <em>&lsaquo;max-size=""&rsaquo;</em>]</code></p>
                    <legend>
                        <strong><?php echo __('Call variables:', 'very-simple-file-upload');?></strong>
                    </legend>
                    <table>
                        <tr>
                            <td valign="top"><code>target=""</code></td>
                            <td valign="top">
                                <?php echo __('Relative path to the main directory of WordPress.', 'very-simple-file-upload');?>
                                <br /><small>
                                    <?php echo __('Disabled:', 'very-simple-file-upload');?><br />
                                    <ul>
                                        <?php 
                                            $disableds = very_simple_file_upload_989_get_disbled_folders();
                                            for ($i = 0; $i <= count($disableds)-1; $i++) {
                                            	echo '<li>'.$disableds[$i].'</li>';
                                            }
                                        ?>
                                    </ul>
                                </small>
                            </td>
                        </tr>
                        <tr>
                            <td valign="top"><code>user=""</code></td>
                            <td valign="top">
                                <?php echo __('If 1, a registered user can upload, not just an administrator.', 'very-simple-file-upload');?>
                                <br /><small><?php echo __('Default:', 'very-simple-file-upload');?> 0</small>
                            </td>
                        </tr>
                        <tr>
                            <td valign="top"><code>accept=""</code></td>
                            <td valign="top">
                                <?php echo __('Comma-separated list of accepted file extensions', 'very-simple-file-upload');?>
                                <br /><small><?php echo __('Default:', 'very-simple-file-upload');?> <?php echo implode(',', very_simple_file_upload_989_get_default_extensions());?></small>
                            </td>
                        </tr>
                        <tr>
                            <td valign="top"><code>max-size=""</code></td>
                            <td valign="top">
                                <?php echo __('Maximum file size in byte', 'very-simple-file-upload');?>
                                <br /><small><?php echo __('Server settings may override.', 'very-simple-file-upload');?></small>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
        </div>
        <?php
    }

    public function page_init() {}

    public function sanitize( $input ) {}

    public function print_section_info() {}



}
