<?php
/*
Plugin Name: Very Simple File Upload
Plugin URI:  http://wpdemo.dovi42.hu/very-simple-file-upload
Description: You can use this simple plugin to upload a file to the server's file system.
Version:     1.10
Author:      Dovi42
Author URI:  http://dovi42.hu/
License:     GPLv2 or later
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: very-simple-file-upload
Generator:   WP Creator - http://wpcreator.hu - 2020-07-05 11:22:01
*/

if ( !defined( 'ABSPATH' ) ) exit;

define('VERY_SIMPLE_FILE_UPLOAD_989_ROOT', dirname(__FILE__));
if (!defined('VERY_SIMPLE_FILE_UPLOAD_989_WP_ROOT')) {
    $path = explode(DS, VERY_SIMPLE_FILE_UPLOAD_989_ROOT);    
    $path = array_slice($path, 0, -3);
    $path = implode(DS, $path).DS;
    define('VERY_SIMPLE_FILE_UPLOAD_989_WP_ROOT', $path);
}

function very_simple_file_upload_989_update() {
    require_once ( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'autoupdate.php' ); 
	
	$plugin_current_version = '1.10'; // Current version
	$plugin_remote_path     = 'http://update.dovi42.hu/very-simple-file-upload/update.php';  
	$plugin_slug            = plugin_basename(__file__);
	$license_user           = get_site_url();
	$license_key            = '<optional license key>';

	if ( $license_user && $license_key && $plugin_remote_path )
	{
		new very_simple_file_upload_989_AutoUpdate ($plugin_current_version, $plugin_remote_path, $plugin_slug, $license_user, $license_key);
	}
}
add_action('init', 'very_simple_file_upload_989_update');


function very_simple_file_upload_989_load_textdomain() {
    load_plugin_textdomain( 'very-simple-file-upload', false, basename( dirname( __file__ )) . '/languages' ); 
}
add_action( 'plugins_loaded', 'very_simple_file_upload_989_load_textdomain' );

function very_simple_file_upload_989_get_disbled_folders() {
    $folders = array(
        '..',
        'wp-admin',
        'wp-includes',
        'wp-content/languages',
        'wp-content/mu-plugins',
        'wp-content/plugins',
        'wp-content/themes',
        'wp-content/upgrade'
    );
    return $folders;
}

function very_simple_file_upload_989_get_default_extensions() {
    $ext = array('jpg','png','doc','docx','xls','xlsx','pdf');
    return $ext;
}

function very_simple_file_upload_989_showError($text, $info) {
    $html = '';
    if (!empty($text)) {
        $html = '<div style="border: 1px solid #ccc;border-left: 4px solid #8B0000;background-color: #FDFDFD;padding: 6px 12px;margin: 6px 0;">' . "\r\n" .
                sprintf( $text, $info ). "\r\n" .
             '</div>' . "\r\n";
    }
    return $html;
}

function very_simple_file_upload_989_get_absolute_path($path) {
    $path = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $path);
    $parts = array_filter(explode(DIRECTORY_SEPARATOR, $path), 'strlen');
    $absolutes = array();
    foreach ($parts as $part) {
        if ('.' == $part) continue;
        if ('..' == $part) {
            array_pop($absolutes);
        } else {
            $absolutes[] = $part;
        }
    }
    return implode(DIRECTORY_SEPARATOR, $absolutes);
}



function very_simple_file_upload_989_shortcode($args) {

    // Enable registered user?
    $enabled = false;
    if (((isset($args['user'])) and ($args['user'] == 1)) and is_user_logged_in()) {
        $enabled = true;
    }

    if (current_user_can('administrator')) {
        $enabled = true;
    }

    if (!$enabled) { return; }
    
    // Set the target?
    if ((!isset($args['target'])) or (empty($args['target']))) {
        $html = very_simple_file_upload_989_showError(
                    __('Upload target not set!', 'very-simple-file-upload'), '');
        return $html; 
    }
    
    // Target not disabled? 
    $target_ok = true;
    $disabled = very_simple_file_upload_989_get_disbled_folders();
    $args['target'] = very_simple_file_upload_989_get_absolute_path($args['target']);


    for ($i = 0; $i <= count($disabled)-1; $i++) {
    	$pos = strpos($args['target'], $disabled[$i]);
        if ($pos !== false) {
            $target_ok = false;
        }
    }
    if (!$target_ok) {
        $html = very_simple_file_upload_989_showError(
                    __('This upload folder not enabled! <em>(%s)</em>', 'very-simple-file-upload'), 
                    $args['target']);
        return $html; 
    }
    
    // Exists target folder?
    if (!is_dir(ABSPATH . $args['target'])) {
        $html = very_simple_file_upload_989_showError(
                    __('Target folder not exists! <em>(%s)</em>', 'very-simple-file-upload'), 
                    $args['target']);
        return $html; 
    }

    // Set the accepted extensions?
    if ((!isset($args['accept'])) or (empty($args['accept']))) {
        $args['accept'] = implode(',', very_simple_file_upload_989_get_default_extensions());
    }

    // If not set max size then set default
    if ((!isset($args['max-size'])) or (empty($args['max-size']))) {
        $args['max-size'] = 0;
    }
    
    $max = very_simple_file_upload_989_parse_size(ini_get('post_max_size'));
    if ($args['max-size'] > $max) {
        $args['max-size'] = $max;
    }
    $max = very_simple_file_upload_989_parse_size(ini_get('upload_max_filesize'));
    if ($args['max-size'] > $max) {
        $args['max-size'] = $max;
    }

	// Elviekben lehetséges többszöri meghívás, ezért a jelző csak egyszer engedi betölteni a szkripteket.
	// In principle, multiple invitations are possible, so the token will only allow you to load scripts once.
	if (!defined('VERY_SIMPLE_FILE_UPLOAD_989')) {
		// A globális beállítások átadódnak a script-ek meghívásához
		// Global settings are passed to invite scripts
		very_simple_file_upload_989_styles_and_scripts_to_frontend();
	}

    // Osztály betöltése, ha kell
    // Load class if needed
    if (!class_exists('JVerySimpleFileUpload989')) {
        include_once( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'class.php');
    }

    // Az alapértelmezett paraméterekkel történik az optiomalizálás
    // Init to default options
    $my_plugin = new JVerySimpleFileUpload989($args);

    $html = $my_plugin->prepareContent();
    
    return $html;
}
add_shortcode('very-simple-file-upload', 'very_simple_file_upload_989_shortcode');

function very_simple_file_upload_989_parse_size($size) {
    $unit = preg_replace('/[^bkmgtpezy]/i', '', $size); // Remove the non-unit characters from the size.
    $size = preg_replace('/[^0-9\.]/', '', $size); // Remove the non-numeric characters from the size.
    if ($unit) {
        // Find the position of the unit in the ordered string which is the power of magnitude to multiply a kilobyte by.
        return round($size * pow(1024, stripos('bkmgtpezy', $unit[0])));
    } else {
        return round($size);
    }
}


function very_simple_file_upload_989_styles_and_scripts_to_frontend()
{
    global $pagenow;

    define('VERY_SIMPLE_FILE_UPLOAD_989', 1);

    // Csak a felhasználói oldalon töltődjenek be a szkriptek
    // Only load scripts on the user page
    if (in_array( $pagenow, array( 'post.php', 'page.php', 'index.php' ))) {

        wp_register_style( 'very-simple-file-upload', plugins_url( 'very-simple-file-upload/assets/css/very-simple-file-upload.css', VERY_SIMPLE_FILE_UPLOAD_989_ROOT ) );
    	wp_enqueue_style( 'very-simple-file-upload' );
        
    	wp_register_script('very-simple-file-upload-js', plugins_url( 'very-simple-file-upload/assets/js/very-simple-file-upload.js', VERY_SIMPLE_FILE_UPLOAD_989_ROOT ), array('jquery'), false, true);

		// Ajax hívás engedélyezése
		// Enable call ajax
		wp_localize_script('very-simple-file-upload-js', 'very_simple_file_upload_989_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
		wp_enqueue_script('very-simple-file-upload-js');
    }
}
// add_action( 'wp_enqueue_scripts', 'very_simple_file_upload_989_styles_and_scripts_to_frontend' );

if ( is_admin() ){ 

    include( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'very-simple-file-upload-setup.php' );
    $my_settings_page = new very_simple_file_upload_989_settings();
    
    function very_simple_file_upload_989_get_extra_meta_links($meta, $file, $data, $status) {

        if (plugin_basename(__FILE__) == $file) {
            $lang = get_bloginfo('language');
            if ($lang == 'hu') {
                $url = 'http://wpdemo.dovi42.hu/egyszeru-fajl-feltoltes';
            } else {
                $url = 'http://wpdemo.dovi42.hu/very-simple-file-upload';
            } 
            $meta[] = '<a href="'.$url.'" target="_blank" title="' . __('Detailed description and examples', 'very-simple-file-upload') . '">'.__('Detailed description and examples', 'very-simple-file-upload').'</a>';

            $meta[]  = '<a href="https://wordpress.org/support/plugin/very-simple-file-upload/reviews/">'.
                       __('Please rating!', 'very-simple-file-upload') . '&nbsp;' .
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '</a>';
        }
        return $meta;
    }
    add_filter("plugin_row_meta", 'very_simple_file_upload_989_get_extra_meta_links', 10, 4);
    
}

// Add settings link to plugins page 
function very_simple_file_upload_989_add_settings_link( $links ) {
    $settings_link = '<a href="options-general.php?page=very-simple-file-upload-setting-admin">' . __( 'Settings' ) . '</a>';
    array_unshift( $links, $settings_link );
  	return $links;
}
$plugin = plugin_basename( __file__ );
add_filter( "plugin_action_links_$plugin", 'very_simple_file_upload_989_add_settings_link' );


function very_simple_file_upload_989_getAlias($text)
{
        $str = trim(mb_strtolower($text, 'UTF-8'));

        $accented = array( "á", "é", "í", "ó", "ö", "ő", "ú", "ü", "ű" );  
        $mask     = array( "a", "e", "i", "o", "o", "o", "u", "u", "u" );  
        $str = str_replace( $accented, $mask, $str );  

        $str = str_replace('-', ' ', $str);
        $str = str_replace('_', ' ', $str);
        $str = preg_replace(array('/\s+/','/[^A-Za-z0-9\-|+.]/'), array('-',''), $str);
        
        return $str;
}


function very_simple_file_upload_989_fileupload()
{
    global $current_user;
    
    if ( !is_user_logged_in() ) {
        $result = '<div><span style="color: red;">'.__('ERROR', 'very-simple-file-upload').'</span> : ' . __('Not logged in user.', 'very-simple-file-upload') . '</div>';
        $data = array(
            'status' => 0,
            'message' => $result
        );
        echo json_encode($data);          
        wp_die();
    }
    
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    $name     = $data['filesName'];
    $files    = $_FILES[$name];

    // Allowed extensions
    if (!isset($data['allowExt'])) {
        $allowExt = very_simple_file_upload_989_get_default_extensions();
    } else {
        $allowExt = explode(',', $data['allowExt']);
    }
    // Disable extensions
    $allowExt = array_diff($allowExt, array('php', 'php4', 'phtml', 'htm', 'html', 'js'));


    // Allowed size
    $maxSize  = $data['maxSize']; // *1000 
    if ($maxSize == null) { $maxSize = 0; }

    $target_dir = $data['uploadDir'];
    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'jdovi42_files.php');
    }
    $target = new JDovi42Files(ABSPATH . $target_dir, 'upload.log');
    $target->checkFolder(ABSPATH . $target_dir);

   
    for ($i = 0; $i <= count($files['name'])-1; $i++) {
        
        $error = array();
        
        $name = very_simple_file_upload_989_getAlias($files['name'][$i]);
        $name = sanitize_text_field($name);
        
        setlocale(LC_ALL,'en_US.UTF-8');
        $path_parts = pathinfo($name);
        $ext  = strtolower(trim($path_parts['extension']));
        $name = $path_parts['filename'];
        $size = $files['size'][$i];

        // Ha nincs megadva fájl.
        if (empty($name)) {
            $error[] = __('File not set.', 'very-simple-file-upload');
        } 
        
        // Ha a fájl típusa nem megfelelő
        if (($allowExt != null) and (!in_array($ext, $allowExt))) {
            $error[] = __('File type not allowed.', 'very-simple-file-upload');
        }
        
        // Ha a fájl mérete nem megfelelő
        if (($maxSize != 0) and ($size > ($maxSize * 1000))) {
            $error[] = __('Files size too big.', 'very-simple-file-upload');
        }

        // Szerveroldali hibák
        switch($files['error'][$i])
		{
			case '1':
				$error[] = __('The uploaded file exceeds the upload_max_filesize directive in php.ini', 'very-simple-file-upload');
				break;
			case '2':
				$error[] = __('The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form', 'very-simple-file-upload');
				break;
			case '3':
				$error[] = __('The uploaded file was only partially uploaded', 'very-simple-file-upload');
				break;
			case '4':
				$error[] = __('No file was uploaded.', 'very-simple-file-upload');
				break;
			case '6':
				$error[] = __('Missing a temporary folder', 'very-simple-file-upload');
				break;
			case '7':
				$error[] = __('Failed to write file to disk', 'very-simple-file-upload');
				break;
			case '8':
				$error[] = __('File upload stopped by extension', 'very-simple-file-upload');
				break;
			case '999':
			default:

		}

        if (empty($target_dir)) {
            $error[] = __('Not set target folder.', 'very-simple-file-upload');
        }

        if (empty($error)) {
            
            $name = $target->getAlias($name);
            $name = $target->getEmptyName($name . '.' . $ext);

            $inFile  = $files['tmp_name'][$i];
            $outFile = ABSPATH . $target_dir .DS. $name;

			if (!move_uploaded_file($inFile, $outFile)) {
				$error[] = __('Failed to move files!', 'very-simple-file-upload') . " (" . $name . ')';
            } else {
                $target->updateDescription($name, $current_user->display_name .'|'. date_i18n(get_option('date_format')) . '|' . date(get_option('time_format')));
                @chmod($outFile, 0664);
                
                if (!empty($data['description'])) {
                    $desc = new JDovi42Files(ABSPATH . $target_dir);
                    $desc->updateDescription($name, $data['description']);
                }
            }
			@unlink($inFile);	
        }
    }

    if (empty($error)) {
        // If not error
        $data = array(
            'status' => 1,
            'message' => __('Documents uploaded successfully.', 'very-simple-file-upload'),
            'token'   => $data['token']
        );
        echo json_encode($data);          
    } else {
        // Error in upload
        $result[] = '<div>'.$name. ' : ' . '<span style="color: red;">'.__('ERROR', 'very-simple-file-upload').'</span> : ' . implode(', ', $error) . '</div>';
        $data = array(
            'status'  => 0,
            'message' => implode('', $result),
            'token'   => $data['token']
        );
        echo json_encode($data);          
    }
    wp_die();
}
add_action( 'wp_ajax_nopriv_very_simple_file_upload_989_fileupload', 'very_simple_file_upload_989_fileupload' );
add_action( 'wp_ajax_very_simple_file_upload_989_fileupload', 'very_simple_file_upload_989_fileupload' );


